#!/usr/bin/perl

#This Script find the and monitor Juniper RPM counters.
#the problem with this mib is that the index is based on SnmpAdminString where each word is prefix with its length and the word is in ascii Decimal format
#any qestions or bugs to nitzan.tzelniker@gmail.com

#use warnings;
use strict;

my $node = $ARGV[0];
my $comm = $ARGV[1];
my $action1 = $ARGV[2];
my $action2 = $ARGV[3];
my $theindex = $ARGV[4];

my $snmppath = "/usr/bin/snmpwalk";
my $snmpget = "/usr/bin/snmpget";
my $version = "2c";
my $jnxFWCounterPacketCount = '.1.3.6.1.4.1.2636.3.5.2.1.4';
my $jnxFWCounterByteCount = '.1.3.6.1.4.1.2636.3.5.2.1.5';
my @index;
my $filter;
my $counter;
my @Counters;

sub indexes {
	my $queryOrIndex = shift;

	my @Index = `$snmppath -On -v $version $node -c $comm $jnxFWCounterPacketCount`;

	foreach (@Index) {

		if ($_ =~m/^\.1\.3\.6\.1\.4\.1\.2636\.3\.5\.2\.1\.4\.(\d+).*\.\d+ \= Counter64.*$/i){ #Find the length of the filter string
		if ($_ =~m/^\.1\.3\.6\.1\.4\.1\.2636\.3\.5\.2\.1\.4\.(\d+)((\.\d+){$1})\.(\d+).*\.\d+ \= Counter64.*$/i){ #Find the filter string and the length of te Counter string
		if ($_ =~m/^\.1\.3\.6\.1\.4\.1\.2636\.3\.5\.2\.1\.4\.(\d+)((\.\d+){$1})\.(\d+)((\.\d+){$4})\.(\d) \= Counter64.*$/i){ # Find the Counter string
			my $counterType = $7;
			my $filter = oid_to_ascii($2);
			my $counter = oid_to_ascii($5);
			if ($queryOrIndex eq "query"){
				push @Counters , "$filter,$counter,$counterType:$filter,$counter,$counterType\n";
			}
			elsif ($queryOrIndex eq "index"){
				push @Counters, "$filter,$counter,$counterType\n" ;
			}
		}
	}
}
}
return @Counters
}
sub get_bytes {
	my $index_value = shift;
	my @values = split /\,/,$index_value;
	my $lengthFilterOid =  length ($values[0]);
	my $lengthCounterOid =  length ($values[1]);
	my $filterOid =  ascii_to_oid($values[0]);
	my $counterOid = ascii_to_oid($values[1]);
	my $counterType = $values[2];
	my $oidIndex =  $lengthFilterOid . $filterOid . '.' . $lengthCounterOid . $counterOid . '.' . $counterType; 
	my @bytes =  split (/ /,`$snmpget -Ov  -v $version $node -c $comm $jnxFWCounterByteCount.$oidIndex`);
	return $bytes[1];
}
sub get_packets {
	my $index_value = shift;
	my @values = split /\,/,$index_value;
	my $lengthFilterOid =  length ($values[0]);
	my $lengthCounterOid =  length ($values[1]);
	my $filterOid =  ascii_to_oid($values[0]);
	my $counterOid = ascii_to_oid($values[1]);
	my $counterType = $values[2];
	my $oidIndex =  $lengthFilterOid . $filterOid . '.' . $lengthCounterOid . $counterOid . '.' . $counterType;
	my @packets =  split (/ /,`$snmpget -Ov  -v $version $node -c $comm $jnxFWCounterPacketCount.$oidIndex`);
	return $packets[1];
}

ARGUMENTS: {
	if ($action1 eq "index") { print indexes("index") ; last ARGUMENTS; }
	if ($action1 eq "query") { print indexes("query") ; last ARGUMENTS; }
	if ($action2 eq "bytes") { print get_bytes("$theindex") ; last ARGUMENTS; }
	if ($action2 eq "packets") { print get_packets("$theindex") ; last ARGUMENTS; }


	print "usage:\n\n./juniper-firewall.pl IP COMMUNITY index\n./juniper-firewall.pl IP COMMUNITY query \n./juniper-firewall.pl IP COMMUNITY get {packets|bytes} index_oid\n";
}


sub oid_to_ascii ($)
{
	## Convert each two-digit hex number back to an ASCII character.
	my @noDotArry = split(/\./,$_[0]);
	my $str = "";
	foreach (@noDotArry){
		if ($_ ne "") {
			$str .= chr($_);
		}
	}
	return $str;
}

sub ascii_to_oid($)
{
	my @chars = split(//,shift);
	my $oid = '';
	foreach (@chars){
		$oid .= '.' . ord ($_);
	}
	return $oid;
}

exit;